<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { useEventSource } from '@vueuse/core'
import { watch, ref, computed, inject } from 'vue'
// @ts-ignore
import MarkdownRenderer from '@/components/general/MarkdownRenderer.vue';
import ChatBubble from '@/components/general/ChatBubble.vue';
import { useBaseStore } from '@/stores/base';
import { storeToRefs } from 'pinia';
import { notificationStatus } from '@/enums/enums';
import { useI18n } from 'vue-i18n';

const props = defineProps<{
    id: string,
    avatar?: string,
    option?: string
}>();
const { t } = useI18n();
const $t = t;
const baseStore = useBaseStore();
const { message: notificationMessage, status: notificationStat } = storeToRefs(baseStore);
const message = ref('');
const emits = defineEmits(['close']);
const configuration = inject<any>('configuration');
const { status, data, error, close } = useEventSource(configuration.aiServer + '/chat/' + props.id);
watch(status, (newVal, oldVal) => {
    if (newVal == 'CLOSED') {
        if(message.value.length > 0)
            emits('close', message.value);
        else{
            notificationMessage.value = $t('ai.chat.error.serviceNotAvailable');
            notificationStat.value = notificationStatus.DANGER;
            emits('close', '');
        }
    }
})

watch(data, (newVal: any, oldVal) => {
    if (newVal !== undefined && newVal !== null) {
        //const localVal = newVal;
        const localVal = JSON.parse(newVal);
        message.value = message.value + localVal;
    }
})

const getAvatarPath = computed(()=>{
    return configuration.apiServer + props.avatar;
});

</script>
<template>
    <div class="flex gap-2 w-full flex-row">
        <div class="size-8">
            <div class="w-full h-full rounded-full text-center leading-8 bg-gray-300 text-gray-500" v-if="!avatar"><i
                    class="ri-user-line ri-lg"></i></div>
            <img class="w-full h-full rounded-full object-contain" :src="getAvatarPath" v-else>
        </div>
        <div class="w-fit max-w-[calc(100dvw-49%)]">
            <ChatBubble position="left" color="#e2e8f0">
                <div class="animate-pulse flex space-x-4" v-if="!message">
                    <div class="flex-1 space-y-6 py-1">
                        <div class="h-2 bg-slate-700 rounded"></div>
                        <div class="space-y-3">
                            <div class="grid grid-cols-3 gap-4">
                                <div class="h-2 bg-slate-700 rounded col-span-2"></div>
                                <div class="h-2 bg-slate-700 rounded col-span-1"></div>
                            </div>
                            <div class="h-2 bg-slate-700 rounded"></div>
                        </div>
                    </div>
                </div>
                <div v-else>
                    <div class="bg-gray-300 w-fit rounded-b-md px-2 -mt-4 select-none" v-if="option">
                        <div>{{ $t(`ai.chat.option.${option}.label`) }}</div>
                    </div>
                    <MarkdownRenderer :source="message" hideSourceCopyButton/>
                </div>
            </ChatBubble>
        </div>
    </div>
</template>